
messagebox(" Script VBS d'affichage sous EXCEL de la liste des services d'un ordinateur avec nom complet,;
 nom court et tat.Le fichier est enregistr sous c:\tempor.xls et sera visualis en tant que page Web.Merci  l'auteur...;
 Excel doit tre disponible sur le PC.")

afile="c:\tempor.vbs"
t0=seconds()
set safe off
set textmerge on to &afile noshow
***********************************
text
' ----------------------------------------------------------
' Script VBS d'affichage sous EXCEL de la liste des services
' d'un ordinateur avec nom complet, nom court et tat
'Le document EXCEL est enregistr dans "c:\tempor.xls"
' Syntaxe :
' ListServ []
' Paramtre :
' : nom NetBIOS de l'ordinateur
' s'il est omis : ordinateur local
'
' ----------------------------------------------------------


Const xlCenter = &HFFFFEFF4
Const xlBottom = &HFFFFEFF5
Const xlContext = &HFFFFEC76
Const msoFalse = 0
Const msoScaleFromTopLeft = 0

Dim Args, Computer, ServiceSet, Network,oXL
Set Network = WScript.CreateObject("WScript.Network")
Set Args = WScript.Arguments
nbargs=args.count

If testarg("?") or testarg("h") Then Syntaxe

If nbargs > 0 Then Computer = UCase(Args(0)) else Computer = Network.ComputerName
Set ServiceSet = GetObject("winmgmts:{impersonationLevel=impersonate}!//" & Computer & "/root/cimv2").InstancesOf("Win32_Service")

Set oXL = WScript.CreateObject("EXCEL.application")
oXL.Visible = False
oXL.screenupdating=TRUE
oXL.Workbooks.Add
oXL.Cells(1,1).Value ="Liste des services de l'ordinateur " & Computer

NL=2
Cellule NL,1,"Nom complet"
Cellule NL,2,"Nom court"
Cellule NL,3,"Dmarrage"
Cellule NL,4,"tat"
For each Service in ServiceSet
NL=NL+1
Cellule NL,1,Service.Caption
Desc=Service.Description
If not IsEmpty(Desc) and not IsNull(Desc) and Desc<>Service.Caption Then
With oXL.Range("A" & NL)
.AddComment
.Comment.Visible = True
.Comment.Text Desc
.Comment.Shape.Select True
oXL.Selection.ShapeRange.ScaleWidth 2, msoFalse, msoScaleFromTopLeft
k=len(Desc)/150
If k<1 then k=1
oXL.Selection.ShapeRange.ScaleHeight k, msoFalse, msoScaleFromTopLeft
oXL.Selection.ShapeRange.SetShapesDefaultProperties
.Comment.Visible = false
End With
End If
Cellule NL,2,Service.Name
Select Case Service.StartMode
Case "Manual"
Cellule NL,3,"Manuel"
Case "Disabled"
Cellule NL,3,"Dsactiv"
Case "Auto"
Cellule NL,3,"Automatique"
Case else
Cellule NL,3,"Problme !"
end select

Etat=Service.State
If Lcase(Etat)="running" Then Cellule NL,4,"Dmarr"
If NL=int(NL/2)*2 Then
oXL.Range("A" & NL & ":D" & NL).Select
oXL.Selection.Interior.ColorIndex = 35
End If
Next
oXL.Range("A1").Select
oXL.Selection.Font.Bold = True
With oXL.Selection.Font
.Name = "Arial"
.Size = 12
End With
oXL.Range("A2:D2").Select
oXL.Selection.Font.Bold = True
oXL.Selection.Interior.ColorIndex = 28

oXL.Columns("A:D").Select
oXL.Selection.Columns.AutoFit

oXL.Columns("C:D").Select
oXL.Selection.HorizontalAlignment = xlCenter

oXL.Rows("3:3").Select
oXL.ActiveWindow.FreezePanes = True

oXL.Sheets(1).Select
oXL.Sheets(1).Name = "Services"
oXL.DisplayAlerts = False
if oXL.Sheets.count > 1 then
compteur = oXL.Sheets.count
for i = compteur to 2 step -1
oXL.Sheets(i).delete
next
end if
oXL.cells(1,1).select
oXL.ActiveWorkbook.SaveAs   "c:\tempor.xls"  
oXL.ActiveWorkbook.SaveAs   "c:\tempor.html"
         

oXL.DisplayAlerts = True
oXL.screenupdating= True
'--------------------------------------------------------------------
Sub Cellule(NL,NC,chaine)
oXL.Cells(NL,NC).Value = Chaine
End Sub
'--------------------------------------------------------------------
Sub Syntaxe
msg=VBCRLF
msg=msg & "Script VBS d'affichage sous EXCEL de la liste des services d'un ordinateur" & VBCRLF 
msg=msg & "avec nom complet, nom court, dmarrage et tat actuel de chaque service." & VBCRLF & VBCRLF
msg=msg & "--------------------------------------------------" & VBCRLF
msg=msg & " Syntaxe :" & VBCRLF 
msg=msg & " ListServ []" & VBCRLF
msg=msg & " Paramtre :" & VBCRLF
msg=msg & " : nom NetBIOS de l'ordinateur" & VBCRLF
msg=msg & " s'il est omis : ordinateur local" & VBCRLF
wscript.echo msg
wscript.quit
End Sub
'--------------------------------------------------------------------
Function testarg(param)
testarg=false
For i = 0 To nbargs-1
curarg=lcase(args(i))
If left(curarg,1)="/" or left(curarg,1)="-" Then
If mid(curarg,2,len(param))=param Then
testarg=true
exit function
End If
End If
Next
End Function
'--------------------------------------------------------------------

endtext
***********************************
set textmerge to

 if file(afile)
 WshShell = CreateObject("WScript.Shell")
 = WshShell.Run(afile, 1, .t.)      &&bloque le processus d'xcution du fichier VBS jusqu' son terme
***********************************
&&  la libration...
t1=seconds()
tcalcul=allt(str(t1-t0))+" sec"

MESSAGEBOX("Termin !"+chr(13)+"Votre PC a ralis un temps de calcul="+tcalcul)

if file("c:\tempor.xls")
apIE=createObject('internetexplorer.application')
apIE.navigate("c:\tempor.xls")
with apIE
.menubar=0
.toolbar=0
.statusbar=0
.top=50
.left=50
.width=800
.height=600
endwith
do while apIE.busy or apIE.readystate#4
enddo
apIE.visible=.t.

if messagebox("Raser les fichiers crs?",4+64,"Nettoyage")=6

set safe off
dele file c:\tempor.vbs
dele file c:\tempor.xls
dele file c:\tempor.html
endi

endi
endi
set safe on